(
	window.f
 	Creates a window and wait for the user to press Esc
	/Mic, 2004
)


include ..\include\windef.f


\ Create two null-terminated strings. The constants will contain the addresses of the strings.
z" Window example" constant #appName
z" MyClass" constant #className


\ Allocate 40 bytes for the window class (actually 4+40)
variable myclass 40 allot
variable msg 28 allot
variable hwnd



\ Window event callback
: win-proc { hWnd uMsg wParam lParam -- val }
	uMsg case
		WM_KEYDOWN of
			wParam VK_ESCAPE =
			if
				NULL NULL WM_CLOSE hWnd call PostMessage
			then
			endof
		
		WM_CLOSE of
			0 call PostQuitMessage
			endof

		WM_DESTROY of
			0 call PostQuitMessage
			endof
		
		default
			\ Call the default window proc. The parameters are already
			\ on the stack, so there's no need to push them.
			\
			\ a@ is used to push the accumulator (eax) onto the stack, which is
			\ necessary if you want to get the returned value from a windows api
			\ function.
			call DefWindowProc a@ exit
		
		endcase
		
		\ Pop all the arguments of the stack.
		\ The ;@ word pops a value of the stack and places it in register eax before returning
		drop drop drop drop 0 ;@



: win-main { hInst -- } 
	\ Fill the window class with zeroes
	myclass 40 0 fill

	\ Initialize the window class structure.
	\ !r+ reads "store reversed, increment", and its stack diagram is (adr n -- adr)
	myclass
	CS_HREDRAW CS_VREDRAW or !r+			\ style 
	' win-proc !r+					\ lpfnWndProc
	8 +
	hInst !r+					\ hInstance
	IDI_APPLICATION NULL call LoadIcon a@ !r+	\ hIcon
	IDC_ARROW NULL call LoadCursor a@ !r+		\ hCursor
	COLOR_WINDOWFRAME !r+				\ hbrBackground
	4 +
	#className !r+					\ lpszClassName
	drop myclass
	call RegisterClass
	
	NULL
	hInst
	NULL
	NULL
	128 300 CW_USEDEFAULT CW_USEDEFAULT
	WS_OVERLAPPEDWINDOW 
	#appName
	#className
	NULL
	call CreateWindowEx a@ hwnd !
	
	SW_SHOWDEFAULT hwnd @ call ShowWindow
	hwnd @ call UpdateWindow

	
	begin
		true while
			0 0 hwnd @ msg call GetMessage a@
			0> if
				msg call TranslateMessage 
				msg call DispatchMessage 
			else
				leave
			then
		repeat ;



NULL call GetModuleHandle win-main
bye 
	
		